// Code generated by smithy-go-codegen DO NOT EDIT.

package apptest

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/apptest/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Lists test run steps.
func (c *Client) ListTestRunSteps(ctx context.Context, params *ListTestRunStepsInput, optFns ...func(*Options)) (*ListTestRunStepsOutput, error) {
	if params == nil {
		params = &ListTestRunStepsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListTestRunSteps", params, optFns, c.addOperationListTestRunStepsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListTestRunStepsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListTestRunStepsInput struct {

	// The test run ID of the test run steps.
	//
	// This member is required.
	TestRunId *string

	// The maximum number of test run steps to return in one page of results.
	MaxResults *int32

	// The token from a previous step to retrieve the next page of results.
	NextToken *string

	// The test case ID of the test run steps.
	TestCaseId *string

	// The test suite ID of the test run steps.
	TestSuiteId *string

	noSmithyDocumentSerde
}

type ListTestRunStepsOutput struct {

	// The test run steps of the response query.
	//
	// This member is required.
	TestRunSteps []types.TestRunStepSummary

	// The token from a previous request to retrieve the next page of results.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListTestRunStepsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListTestRunSteps{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListTestRunSteps{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListTestRunSteps"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpListTestRunStepsValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListTestRunSteps(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// ListTestRunStepsPaginatorOptions is the paginator options for ListTestRunSteps
type ListTestRunStepsPaginatorOptions struct {
	// The maximum number of test run steps to return in one page of results.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListTestRunStepsPaginator is a paginator for ListTestRunSteps
type ListTestRunStepsPaginator struct {
	options   ListTestRunStepsPaginatorOptions
	client    ListTestRunStepsAPIClient
	params    *ListTestRunStepsInput
	nextToken *string
	firstPage bool
}

// NewListTestRunStepsPaginator returns a new ListTestRunStepsPaginator
func NewListTestRunStepsPaginator(client ListTestRunStepsAPIClient, params *ListTestRunStepsInput, optFns ...func(*ListTestRunStepsPaginatorOptions)) *ListTestRunStepsPaginator {
	if params == nil {
		params = &ListTestRunStepsInput{}
	}

	options := ListTestRunStepsPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListTestRunStepsPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListTestRunStepsPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListTestRunSteps page.
func (p *ListTestRunStepsPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListTestRunStepsOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListTestRunSteps(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListTestRunStepsAPIClient is a client that implements the ListTestRunSteps
// operation.
type ListTestRunStepsAPIClient interface {
	ListTestRunSteps(context.Context, *ListTestRunStepsInput, ...func(*Options)) (*ListTestRunStepsOutput, error)
}

var _ ListTestRunStepsAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListTestRunSteps(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListTestRunSteps",
	}
}
