// Code generated by smithy-go-codegen DO NOT EDIT.

package autoscalingplans

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/autoscalingplans/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Creates a scaling plan.
func (c *Client) CreateScalingPlan(ctx context.Context, params *CreateScalingPlanInput, optFns ...func(*Options)) (*CreateScalingPlanOutput, error) {
	if params == nil {
		params = &CreateScalingPlanInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "CreateScalingPlan", params, optFns, c.addOperationCreateScalingPlanMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*CreateScalingPlanOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type CreateScalingPlanInput struct {

	// A CloudFormation stack or set of tags. You can create one scaling plan per
	// application source.
	//
	// For more information, see [ApplicationSource] in the AWS Auto Scaling API Reference.
	//
	// [ApplicationSource]: https://docs.aws.amazon.com/autoscaling/plans/APIReference/API_ApplicationSource.html
	//
	// This member is required.
	ApplicationSource *types.ApplicationSource

	// The scaling instructions.
	//
	// For more information, see [ScalingInstruction] in the AWS Auto Scaling API Reference.
	//
	// [ScalingInstruction]: https://docs.aws.amazon.com/autoscaling/plans/APIReference/API_ScalingInstruction.html
	//
	// This member is required.
	ScalingInstructions []types.ScalingInstruction

	// The name of the scaling plan. Names cannot contain vertical bars, colons, or
	// forward slashes.
	//
	// This member is required.
	ScalingPlanName *string

	noSmithyDocumentSerde
}

type CreateScalingPlanOutput struct {

	// The version number of the scaling plan. This value is always 1 . Currently, you
	// cannot have multiple scaling plan versions.
	//
	// This member is required.
	ScalingPlanVersion *int64

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationCreateScalingPlanMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsAwsjson11_serializeOpCreateScalingPlan{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsAwsjson11_deserializeOpCreateScalingPlan{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "CreateScalingPlan"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpCreateScalingPlanValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opCreateScalingPlan(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opCreateScalingPlan(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "CreateScalingPlan",
	}
}
