// Code generated by smithy-go-codegen DO NOT EDIT.

package cleanrooms

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/cleanrooms/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Returns an array that summarizes each privacy budget template in a specified
// collaboration.
func (c *Client) ListCollaborationPrivacyBudgetTemplates(ctx context.Context, params *ListCollaborationPrivacyBudgetTemplatesInput, optFns ...func(*Options)) (*ListCollaborationPrivacyBudgetTemplatesOutput, error) {
	if params == nil {
		params = &ListCollaborationPrivacyBudgetTemplatesInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListCollaborationPrivacyBudgetTemplates", params, optFns, c.addOperationListCollaborationPrivacyBudgetTemplatesMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListCollaborationPrivacyBudgetTemplatesOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListCollaborationPrivacyBudgetTemplatesInput struct {

	// A unique identifier for one of your collaborations.
	//
	// This member is required.
	CollaborationIdentifier *string

	// The maximum size of the results that is returned per call. Service chooses a
	// default if it has not been set. Service may return a nextToken even if the
	// maximum results has not been met.
	MaxResults *int32

	// The token value retrieved from a previous call to access the next page of
	// results.
	NextToken *string

	noSmithyDocumentSerde
}

type ListCollaborationPrivacyBudgetTemplatesOutput struct {

	// An array that summarizes the collaboration privacy budget templates. The
	// summary includes collaboration information, creation information, the privacy
	// budget type.
	//
	// This member is required.
	CollaborationPrivacyBudgetTemplateSummaries []types.CollaborationPrivacyBudgetTemplateSummary

	// The token value retrieved from a previous call to access the next page of
	// results.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListCollaborationPrivacyBudgetTemplatesMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListCollaborationPrivacyBudgetTemplates{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListCollaborationPrivacyBudgetTemplates{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListCollaborationPrivacyBudgetTemplates"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpListCollaborationPrivacyBudgetTemplatesValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListCollaborationPrivacyBudgetTemplates(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// ListCollaborationPrivacyBudgetTemplatesPaginatorOptions is the paginator
// options for ListCollaborationPrivacyBudgetTemplates
type ListCollaborationPrivacyBudgetTemplatesPaginatorOptions struct {
	// The maximum size of the results that is returned per call. Service chooses a
	// default if it has not been set. Service may return a nextToken even if the
	// maximum results has not been met.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListCollaborationPrivacyBudgetTemplatesPaginator is a paginator for
// ListCollaborationPrivacyBudgetTemplates
type ListCollaborationPrivacyBudgetTemplatesPaginator struct {
	options   ListCollaborationPrivacyBudgetTemplatesPaginatorOptions
	client    ListCollaborationPrivacyBudgetTemplatesAPIClient
	params    *ListCollaborationPrivacyBudgetTemplatesInput
	nextToken *string
	firstPage bool
}

// NewListCollaborationPrivacyBudgetTemplatesPaginator returns a new
// ListCollaborationPrivacyBudgetTemplatesPaginator
func NewListCollaborationPrivacyBudgetTemplatesPaginator(client ListCollaborationPrivacyBudgetTemplatesAPIClient, params *ListCollaborationPrivacyBudgetTemplatesInput, optFns ...func(*ListCollaborationPrivacyBudgetTemplatesPaginatorOptions)) *ListCollaborationPrivacyBudgetTemplatesPaginator {
	if params == nil {
		params = &ListCollaborationPrivacyBudgetTemplatesInput{}
	}

	options := ListCollaborationPrivacyBudgetTemplatesPaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListCollaborationPrivacyBudgetTemplatesPaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListCollaborationPrivacyBudgetTemplatesPaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListCollaborationPrivacyBudgetTemplates page.
func (p *ListCollaborationPrivacyBudgetTemplatesPaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListCollaborationPrivacyBudgetTemplatesOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListCollaborationPrivacyBudgetTemplates(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

// ListCollaborationPrivacyBudgetTemplatesAPIClient is a client that implements
// the ListCollaborationPrivacyBudgetTemplates operation.
type ListCollaborationPrivacyBudgetTemplatesAPIClient interface {
	ListCollaborationPrivacyBudgetTemplates(context.Context, *ListCollaborationPrivacyBudgetTemplatesInput, ...func(*Options)) (*ListCollaborationPrivacyBudgetTemplatesOutput, error)
}

var _ ListCollaborationPrivacyBudgetTemplatesAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListCollaborationPrivacyBudgetTemplates(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListCollaborationPrivacyBudgetTemplates",
	}
}
