// Code generated by smithy-go-codegen DO NOT EDIT.

package deadline

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/deadline/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Lists storage profiles for a queue.
func (c *Client) ListStorageProfilesForQueue(ctx context.Context, params *ListStorageProfilesForQueueInput, optFns ...func(*Options)) (*ListStorageProfilesForQueueOutput, error) {
	if params == nil {
		params = &ListStorageProfilesForQueueInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "ListStorageProfilesForQueue", params, optFns, c.addOperationListStorageProfilesForQueueMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*ListStorageProfilesForQueueOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type ListStorageProfilesForQueueInput struct {

	// The farm ID of the queue's storage profile.
	//
	// This member is required.
	FarmId *string

	// The queue ID for the storage profile.
	//
	// This member is required.
	QueueId *string

	// The maximum number of results to return. Use this parameter with NextToken to
	// get results as a set of sequential pages.
	MaxResults *int32

	// The token for the next set of results, or null to start from the beginning.
	NextToken *string

	noSmithyDocumentSerde
}

type ListStorageProfilesForQueueOutput struct {

	// The storage profiles in the queue.
	//
	// This member is required.
	StorageProfiles []types.StorageProfileSummary

	// If Deadline Cloud returns nextToken , then there are more results available. The
	// value of nextToken is a unique pagination token for each page. To retrieve the
	// next page, call the operation again using the returned token. Keep all other
	// arguments unchanged. If no results remain, then nextToken is set to null . Each
	// pagination token expires after 24 hours. If you provide a token that isn't
	// valid, then you receive an HTTP 400 ValidationException error.
	NextToken *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationListStorageProfilesForQueueMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpListStorageProfilesForQueue{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpListStorageProfilesForQueue{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "ListStorageProfilesForQueue"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addEndpointPrefix_opListStorageProfilesForQueueMiddleware(stack); err != nil {
		return err
	}
	if err = addOpListStorageProfilesForQueueValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opListStorageProfilesForQueue(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

// ListStorageProfilesForQueuePaginatorOptions is the paginator options for
// ListStorageProfilesForQueue
type ListStorageProfilesForQueuePaginatorOptions struct {
	// The maximum number of results to return. Use this parameter with NextToken to
	// get results as a set of sequential pages.
	Limit int32

	// Set to true if pagination should stop if the service returns a pagination token
	// that matches the most recent token provided to the service.
	StopOnDuplicateToken bool
}

// ListStorageProfilesForQueuePaginator is a paginator for
// ListStorageProfilesForQueue
type ListStorageProfilesForQueuePaginator struct {
	options   ListStorageProfilesForQueuePaginatorOptions
	client    ListStorageProfilesForQueueAPIClient
	params    *ListStorageProfilesForQueueInput
	nextToken *string
	firstPage bool
}

// NewListStorageProfilesForQueuePaginator returns a new
// ListStorageProfilesForQueuePaginator
func NewListStorageProfilesForQueuePaginator(client ListStorageProfilesForQueueAPIClient, params *ListStorageProfilesForQueueInput, optFns ...func(*ListStorageProfilesForQueuePaginatorOptions)) *ListStorageProfilesForQueuePaginator {
	if params == nil {
		params = &ListStorageProfilesForQueueInput{}
	}

	options := ListStorageProfilesForQueuePaginatorOptions{}
	if params.MaxResults != nil {
		options.Limit = *params.MaxResults
	}

	for _, fn := range optFns {
		fn(&options)
	}

	return &ListStorageProfilesForQueuePaginator{
		options:   options,
		client:    client,
		params:    params,
		firstPage: true,
		nextToken: params.NextToken,
	}
}

// HasMorePages returns a boolean indicating whether more pages are available
func (p *ListStorageProfilesForQueuePaginator) HasMorePages() bool {
	return p.firstPage || (p.nextToken != nil && len(*p.nextToken) != 0)
}

// NextPage retrieves the next ListStorageProfilesForQueue page.
func (p *ListStorageProfilesForQueuePaginator) NextPage(ctx context.Context, optFns ...func(*Options)) (*ListStorageProfilesForQueueOutput, error) {
	if !p.HasMorePages() {
		return nil, fmt.Errorf("no more pages available")
	}

	params := *p.params
	params.NextToken = p.nextToken

	var limit *int32
	if p.options.Limit > 0 {
		limit = &p.options.Limit
	}
	params.MaxResults = limit

	optFns = append([]func(*Options){
		addIsPaginatorUserAgent,
	}, optFns...)
	result, err := p.client.ListStorageProfilesForQueue(ctx, &params, optFns...)
	if err != nil {
		return nil, err
	}
	p.firstPage = false

	prevToken := p.nextToken
	p.nextToken = result.NextToken

	if p.options.StopOnDuplicateToken &&
		prevToken != nil &&
		p.nextToken != nil &&
		*prevToken == *p.nextToken {
		p.nextToken = nil
	}

	return result, nil
}

type endpointPrefix_opListStorageProfilesForQueueMiddleware struct {
}

func (*endpointPrefix_opListStorageProfilesForQueueMiddleware) ID() string {
	return "EndpointHostPrefix"
}

func (m *endpointPrefix_opListStorageProfilesForQueueMiddleware) HandleFinalize(ctx context.Context, in middleware.FinalizeInput, next middleware.FinalizeHandler) (
	out middleware.FinalizeOutput, metadata middleware.Metadata, err error,
) {
	if smithyhttp.GetHostnameImmutable(ctx) || smithyhttp.IsEndpointHostPrefixDisabled(ctx) {
		return next.HandleFinalize(ctx, in)
	}

	req, ok := in.Request.(*smithyhttp.Request)
	if !ok {
		return out, metadata, fmt.Errorf("unknown transport type %T", in.Request)
	}

	req.URL.Host = "management." + req.URL.Host

	return next.HandleFinalize(ctx, in)
}
func addEndpointPrefix_opListStorageProfilesForQueueMiddleware(stack *middleware.Stack) error {
	return stack.Finalize.Insert(&endpointPrefix_opListStorageProfilesForQueueMiddleware{}, "ResolveEndpointV2", middleware.After)
}

// ListStorageProfilesForQueueAPIClient is a client that implements the
// ListStorageProfilesForQueue operation.
type ListStorageProfilesForQueueAPIClient interface {
	ListStorageProfilesForQueue(context.Context, *ListStorageProfilesForQueueInput, ...func(*Options)) (*ListStorageProfilesForQueueOutput, error)
}

var _ ListStorageProfilesForQueueAPIClient = (*Client)(nil)

func newServiceMetadataMiddleware_opListStorageProfilesForQueue(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "ListStorageProfilesForQueue",
	}
}
