// Code generated by smithy-go-codegen DO NOT EDIT.

package macie2

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/macie2/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Changes the status of automated sensitive data discovery for one or more
// accounts.
func (c *Client) BatchUpdateAutomatedDiscoveryAccounts(ctx context.Context, params *BatchUpdateAutomatedDiscoveryAccountsInput, optFns ...func(*Options)) (*BatchUpdateAutomatedDiscoveryAccountsOutput, error) {
	if params == nil {
		params = &BatchUpdateAutomatedDiscoveryAccountsInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "BatchUpdateAutomatedDiscoveryAccounts", params, optFns, c.addOperationBatchUpdateAutomatedDiscoveryAccountsMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*BatchUpdateAutomatedDiscoveryAccountsOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type BatchUpdateAutomatedDiscoveryAccountsInput struct {

	// An array of objects, one for each account to change the status of automated
	// sensitive data discovery for. Each object specifies the Amazon Web Services
	// account ID for an account and a new status for that account.
	Accounts []types.AutomatedDiscoveryAccountUpdate

	noSmithyDocumentSerde
}

type BatchUpdateAutomatedDiscoveryAccountsOutput struct {

	// An array of objects, one for each account whose status wasn’t changed. Each
	// object identifies the account and explains why the status of automated sensitive
	// data discovery wasn’t changed for the account. This value is null if the request
	// succeeded for all specified accounts.
	Errors []types.AutomatedDiscoveryAccountUpdateError

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationBatchUpdateAutomatedDiscoveryAccountsMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpBatchUpdateAutomatedDiscoveryAccounts{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpBatchUpdateAutomatedDiscoveryAccounts{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "BatchUpdateAutomatedDiscoveryAccounts"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opBatchUpdateAutomatedDiscoveryAccounts(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opBatchUpdateAutomatedDiscoveryAccounts(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "BatchUpdateAutomatedDiscoveryAccounts",
	}
}
