// Code generated by smithy-go-codegen DO NOT EDIT.

package mediaconnect

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/mediaconnect/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Updates the configuration of an existing Gateway Instance.
func (c *Client) UpdateGatewayInstance(ctx context.Context, params *UpdateGatewayInstanceInput, optFns ...func(*Options)) (*UpdateGatewayInstanceOutput, error) {
	if params == nil {
		params = &UpdateGatewayInstanceInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "UpdateGatewayInstance", params, optFns, c.addOperationUpdateGatewayInstanceMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*UpdateGatewayInstanceOutput)
	out.ResultMetadata = metadata
	return out, nil
}

// A request to update gateway instance state.
type UpdateGatewayInstanceInput struct {

	// The Amazon Resource Name (ARN) of the instance that you want to update.
	//
	// This member is required.
	GatewayInstanceArn *string

	// The availability of the instance to host new bridges. The bridgePlacement
	// property can be LOCKED or AVAILABLE. If it is LOCKED, no new bridges can be
	// deployed to this instance. If it is AVAILABLE, new bridges can be added to this
	// instance.
	BridgePlacement types.BridgePlacement

	noSmithyDocumentSerde
}

type UpdateGatewayInstanceOutput struct {

	// The availability of the instance to host new bridges. The bridgePlacement
	// property can be LOCKED or AVAILABLE. If it is LOCKED, no new bridges can be
	// deployed to this instance. If it is AVAILABLE, new bridges can be added to this
	// instance.
	BridgePlacement types.BridgePlacement

	// The Amazon Resource Name (ARN) of the instance.
	GatewayInstanceArn *string

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationUpdateGatewayInstanceMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsRestjson1_serializeOpUpdateGatewayInstance{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsRestjson1_deserializeOpUpdateGatewayInstance{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "UpdateGatewayInstance"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpUpdateGatewayInstanceValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opUpdateGatewayInstance(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opUpdateGatewayInstance(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "UpdateGatewayInstance",
	}
}
