// Code generated by smithy-go-codegen DO NOT EDIT.

// Package medicalimaging provides the API client, operations, and parameter types
// for AWS Health Imaging.
//
// This is the AWS HealthImaging API Reference. AWS HealthImaging is a HIPAA
// eligible service that empowers healthcare providers, life science organizations,
// and their software partners to store, analyze, and share medical images in the
// cloud at petabyte scale. For an introduction to the service, see the [AWS HealthImaging Developer Guide].
//
// We recommend using one of the AWS Software Development Kits (SDKs) for your
// programming language, as they take care of request authentication,
// serialization, and connection management. For more information, see [Tools to build on AWS].
//
// The following sections list AWS HealthImaging API actions categorized according
// to functionality. Links are provided to actions within this Reference, along
// with links back to corresponding sections in the AWS HealthImaging Developer
// Guide where you can view tested code examples.
//
// # Data store actions
//
// [CreateDatastore]
//   - – See [Creating a data store].
//
// [GetDatastore]
//   - – See [Getting data store properties].
//
// [ListDatastores]
//   - – See [Listing data stores].
//
// [DeleteDatastore]
//   - – See [Deleting a data store].
//
// # Import job actions
//
// [StartDICOMImportJob]
//   - – See [Starting an import job].
//
// [GetDICOMImportJob]
//   - – See [Getting import job properties].
//
// [ListDICOMImportJobs]
//   - – See [Listing import jobs].
//
// # Image set access actions
//
// [SearchImageSets]
//   - – See [Searching image sets].
//
// [GetImageSet]
//   - – See [Getting image set properties].
//
// [GetImageSetMetadata]
//   - – See [Getting image set metadata].
//
// [GetImageFrame]
//   - – See [Getting image set pixel data].
//
// # Image set modification actions
//
// [ListImageSetVersions]
//   - – See [Listing image set versions].
//
// [UpdateImageSetMetadata]
//   - – See [Updating image set metadata].
//
// [CopyImageSet]
//   - – See [Copying an image set].
//
// [DeleteImageSet]
//   - – See [Deleting an image set].
//
// # Tagging actions
//
// [TagResource]
//   - – See [Tagging a resource].
//
// [ListTagsForResource]
//   - – See [Listing tags for a resource].
//
// [UntagResource]
//   - – See [Untagging a resource].
//
// [ListDICOMImportJobs]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListDICOMImportJobs.html
// [CopyImageSet]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_CopyImageSet.html
// [TagResource]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_TagResource.html
// [Updating image set metadata]: https://docs.aws.amazon.com/healthimaging/latest/devguide/update-image-set-metadata.html
// [Creating a data store]: https://docs.aws.amazon.com/healthimaging/latest/devguide/create-data-store.html
// [GetDatastore]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetDatastore.html
// [Tagging a resource]: https://docs.aws.amazon.com/healthimaging/latest/devguide/tag-resource.html
// [Listing data stores]: https://docs.aws.amazon.com/healthimaging/latest/devguide/list-data-stores.html
// [DeleteDatastore]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_DeleteDatastore.html
// [Getting image set pixel data]: https://docs.aws.amazon.com/healthimaging/latest/devguide/get-image-frame.html
// [CreateDatastore]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_CreateDatastore.html
// [ListImageSetVersions]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListImageSetVersions.html
// [GetImageFrame]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetImageFrame.html
// [Copying an image set]: https://docs.aws.amazon.com/healthimaging/latest/devguide/copy-image-set.html
// [GetImageSet]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetImageSet.html
// [Listing image set versions]: https://docs.aws.amazon.com/healthimaging/latest/devguide/list-image-set-versions.html
// [DeleteImageSet]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_DeleteImageSet.html
// [GetImageSetMetadata]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetImageSetMetadata.html
// [Starting an import job]: https://docs.aws.amazon.com/healthimaging/latest/devguide/start-dicom-import-job.html
// [SearchImageSets]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_SearchImageSets.html
// [UpdateImageSetMetadata]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_UpdateImageSetMetadata.html
// [Deleting a data store]: https://docs.aws.amazon.com/healthimaging/latest/devguide/delete-data-store.html
// [Listing import jobs]: https://docs.aws.amazon.com/healthimaging/latest/devguide/list-dicom-import-jobs.html
// [Deleting an image set]: https://docs.aws.amazon.com/healthimaging/latest/devguide/delete-image-set.html
// [Listing tags for a resource]: https://docs.aws.amazon.com/healthimaging/latest/devguide/list-tag-resource.html
// [Getting image set metadata]: https://docs.aws.amazon.com/healthimaging/latest/devguide/get-image-set-metadata.html
// [Untagging a resource]: https://docs.aws.amazon.com/healthimaging/latest/devguide/untag-resource.html
// [ListDatastores]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListDatastores.html
// [UntagResource]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_UntagResource.html
// [StartDICOMImportJob]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_StartDICOMImportJob.html
// [Getting import job properties]: https://docs.aws.amazon.com/healthimaging/latest/devguide/get-dicom-import-job.html
// [Getting data store properties]: https://docs.aws.amazon.com/healthimaging/latest/devguide/get-data-store.html
// [Searching image sets]: https://docs.aws.amazon.com/healthimaging/latest/devguide/search-image-sets.html
// [GetDICOMImportJob]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_GetDICOMImportJob.html
// [AWS HealthImaging Developer Guide]: https://docs.aws.amazon.com/healthimaging/latest/devguide/what-is.html
// [Tools to build on AWS]: http://aws.amazon.com/developer/tools
// [Getting image set properties]: https://docs.aws.amazon.com/healthimaging/latest/devguide/get-image-set-properties.html
// [ListTagsForResource]: https://docs.aws.amazon.com/healthimaging/latest/APIReference/API_ListTagsForResource.html
package medicalimaging
