// Code generated by smithy-go-codegen DO NOT EDIT.

// Package opsworks provides the API client, operations, and parameter types for
// AWS OpsWorks.
//
// # OpsWorks
//
// Welcome to the OpsWorks Stacks API Reference. This guide provides descriptions,
// syntax, and usage examples for OpsWorks Stacks actions and data types, including
// common parameters and error codes.
//
// OpsWorks Stacks is an application management service that provides an
// integrated experience for managing the complete application lifecycle. For
// information about OpsWorks, see the [OpsWorks]information page.
//
// # SDKs and CLI
//
// Use the OpsWorks Stacks API by using the Command Line Interface (CLI) or by
// using one of the Amazon Web Services SDKs to implement applications in your
// preferred language. For more information, see:
//
// [CLI]
//
// [SDK for Java]
//
// [SDK for .NET]
//
// [SDK for PHP]
//
// [SDK for Ruby]
//
// [Amazon Web Services SDK for Node.js]
//
// [SDK for Python (Boto)]
//
// # Endpoints
//
// OpsWorks Stacks supports the following endpoints, all HTTPS. You must connect
// to one of the following endpoints. Stacks can only be accessed or managed within
// the endpoint in which they are created.
//
//   - opsworks.us-east-1.amazonaws.com
//
//   - opsworks.us-east-2.amazonaws.com
//
//   - opsworks.us-west-1.amazonaws.com
//
//   - opsworks.us-west-2.amazonaws.com
//
//   - opsworks.ca-central-1.amazonaws.com (API only; not available in the Amazon
//     Web Services Management Console)
//
//   - opsworks.eu-west-1.amazonaws.com
//
//   - opsworks.eu-west-2.amazonaws.com
//
//   - opsworks.eu-west-3.amazonaws.com
//
//   - opsworks.eu-central-1.amazonaws.com
//
//   - opsworks.ap-northeast-1.amazonaws.com
//
//   - opsworks.ap-northeast-2.amazonaws.com
//
//   - opsworks.ap-south-1.amazonaws.com
//
//   - opsworks.ap-southeast-1.amazonaws.com
//
//   - opsworks.ap-southeast-2.amazonaws.com
//
//   - opsworks.sa-east-1.amazonaws.com
//
// # Chef Versions
//
// When you call CreateStack, CloneStack, or UpdateStack we recommend you use the ConfigurationManager parameter
// to specify the Chef version. The recommended and default value for Linux stacks
// is currently 12. Windows stacks use Chef 12.2. For more information, see [Chef Versions].
//
// You can specify Chef 12, 11.10, or 11.4 for your Linux stack. We recommend
// migrating your existing Linux stacks to Chef 12 as soon as possible.
//
// [CLI]: https://docs.aws.amazon.com/cli/latest/userguide/cli-chap-welcome.html
// [OpsWorks]: http://aws.amazon.com/opsworks/
// [SDK for Python (Boto)]: http://docs.pythonboto.org/en/latest/ref/opsworks.html
// [SDK for Java]: https://docs.aws.amazon.com/AWSJavaSDK/latest/javadoc/com/amazonaws/services/opsworks/AWSOpsWorksClient.html
// [SDK for .NET]: https://docs.aws.amazon.com/sdkfornet/v3/apidocs/items/OpsWorks/NOpsWorks.html
// [Amazon Web Services SDK for Node.js]: http://aws.amazon.com/documentation/sdkforjavascript/
// [SDK for PHP]: https://docs.aws.amazon.com/aws-sdk-php/v3/api/class-Aws.OpsWorks.OpsWorksClient.html
// [SDK for Ruby]: http://docs.aws.amazon.com/sdkforruby/api/
// [Chef Versions]: https://docs.aws.amazon.com/opsworks/latest/userguide/workingcookbook-chef11.html
package opsworks
