// Code generated by smithy-go-codegen DO NOT EDIT.

package types

type KeyAlgorithm string

// Enum values for KeyAlgorithm
const (
	KeyAlgorithmTdes2key KeyAlgorithm = "TDES_2KEY"
	KeyAlgorithmTdes3key KeyAlgorithm = "TDES_3KEY"
	KeyAlgorithmAes128   KeyAlgorithm = "AES_128"
	KeyAlgorithmAes192   KeyAlgorithm = "AES_192"
	KeyAlgorithmAes256   KeyAlgorithm = "AES_256"
	KeyAlgorithmRsa2048  KeyAlgorithm = "RSA_2048"
	KeyAlgorithmRsa3072  KeyAlgorithm = "RSA_3072"
	KeyAlgorithmRsa4096  KeyAlgorithm = "RSA_4096"
)

// Values returns all known values for KeyAlgorithm. Note that this can be
// expanded in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyAlgorithm) Values() []KeyAlgorithm {
	return []KeyAlgorithm{
		"TDES_2KEY",
		"TDES_3KEY",
		"AES_128",
		"AES_192",
		"AES_256",
		"RSA_2048",
		"RSA_3072",
		"RSA_4096",
	}
}

type KeyCheckValueAlgorithm string

// Enum values for KeyCheckValueAlgorithm
const (
	KeyCheckValueAlgorithmCmac     KeyCheckValueAlgorithm = "CMAC"
	KeyCheckValueAlgorithmAnsiX924 KeyCheckValueAlgorithm = "ANSI_X9_24"
)

// Values returns all known values for KeyCheckValueAlgorithm. Note that this can
// be expanded in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyCheckValueAlgorithm) Values() []KeyCheckValueAlgorithm {
	return []KeyCheckValueAlgorithm{
		"CMAC",
		"ANSI_X9_24",
	}
}

type KeyClass string

// Enum values for KeyClass
const (
	KeyClassSymmetricKey      KeyClass = "SYMMETRIC_KEY"
	KeyClassAsymmetricKeyPair KeyClass = "ASYMMETRIC_KEY_PAIR"
	KeyClassPrivateKey        KeyClass = "PRIVATE_KEY"
	KeyClassPublicKey         KeyClass = "PUBLIC_KEY"
)

// Values returns all known values for KeyClass. Note that this can be expanded in
// the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyClass) Values() []KeyClass {
	return []KeyClass{
		"SYMMETRIC_KEY",
		"ASYMMETRIC_KEY_PAIR",
		"PRIVATE_KEY",
		"PUBLIC_KEY",
	}
}

type KeyExportability string

// Enum values for KeyExportability
const (
	KeyExportabilityExportable    KeyExportability = "EXPORTABLE"
	KeyExportabilityNonExportable KeyExportability = "NON_EXPORTABLE"
	KeyExportabilitySensitive     KeyExportability = "SENSITIVE"
)

// Values returns all known values for KeyExportability. Note that this can be
// expanded in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyExportability) Values() []KeyExportability {
	return []KeyExportability{
		"EXPORTABLE",
		"NON_EXPORTABLE",
		"SENSITIVE",
	}
}

type KeyMaterialType string

// Enum values for KeyMaterialType
const (
	KeyMaterialTypeTr34KeyBlock                KeyMaterialType = "TR34_KEY_BLOCK"
	KeyMaterialTypeTr31KeyBlock                KeyMaterialType = "TR31_KEY_BLOCK"
	KeyMaterialTypeRootPublicKeyCertificate    KeyMaterialType = "ROOT_PUBLIC_KEY_CERTIFICATE"
	KeyMaterialTypeTrustedPublicKeyCertificate KeyMaterialType = "TRUSTED_PUBLIC_KEY_CERTIFICATE"
	KeyMaterialTypeKeyCryptogram               KeyMaterialType = "KEY_CRYPTOGRAM"
)

// Values returns all known values for KeyMaterialType. Note that this can be
// expanded in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyMaterialType) Values() []KeyMaterialType {
	return []KeyMaterialType{
		"TR34_KEY_BLOCK",
		"TR31_KEY_BLOCK",
		"ROOT_PUBLIC_KEY_CERTIFICATE",
		"TRUSTED_PUBLIC_KEY_CERTIFICATE",
		"KEY_CRYPTOGRAM",
	}
}

type KeyOrigin string

// Enum values for KeyOrigin
const (
	KeyOriginExternal               KeyOrigin = "EXTERNAL"
	KeyOriginAwsPaymentCryptography KeyOrigin = "AWS_PAYMENT_CRYPTOGRAPHY"
)

// Values returns all known values for KeyOrigin. Note that this can be expanded
// in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyOrigin) Values() []KeyOrigin {
	return []KeyOrigin{
		"EXTERNAL",
		"AWS_PAYMENT_CRYPTOGRAPHY",
	}
}

type KeyState string

// Enum values for KeyState
const (
	KeyStateCreateInProgress KeyState = "CREATE_IN_PROGRESS"
	KeyStateCreateComplete   KeyState = "CREATE_COMPLETE"
	KeyStateDeletePending    KeyState = "DELETE_PENDING"
	KeyStateDeleteComplete   KeyState = "DELETE_COMPLETE"
)

// Values returns all known values for KeyState. Note that this can be expanded in
// the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyState) Values() []KeyState {
	return []KeyState{
		"CREATE_IN_PROGRESS",
		"CREATE_COMPLETE",
		"DELETE_PENDING",
		"DELETE_COMPLETE",
	}
}

type KeyUsage string

// Enum values for KeyUsage
const (
	KeyUsageTr31B0BaseDerivationKey                KeyUsage = "TR31_B0_BASE_DERIVATION_KEY"
	KeyUsageTr31C0CardVerificationKey              KeyUsage = "TR31_C0_CARD_VERIFICATION_KEY"
	KeyUsageTr31D0SymmetricDataEncryptionKey       KeyUsage = "TR31_D0_SYMMETRIC_DATA_ENCRYPTION_KEY"
	KeyUsageTr31D1AsymmetricKeyForDataEncryption   KeyUsage = "TR31_D1_ASYMMETRIC_KEY_FOR_DATA_ENCRYPTION"
	KeyUsageTr31E0EmvMkeyAppCryptograms            KeyUsage = "TR31_E0_EMV_MKEY_APP_CRYPTOGRAMS"
	KeyUsageTr31E1EmvMkeyConfidentiality           KeyUsage = "TR31_E1_EMV_MKEY_CONFIDENTIALITY"
	KeyUsageTr31E2EmvMkeyIntegrity                 KeyUsage = "TR31_E2_EMV_MKEY_INTEGRITY"
	KeyUsageTr31E4EmvMkeyDynamicNumbers            KeyUsage = "TR31_E4_EMV_MKEY_DYNAMIC_NUMBERS"
	KeyUsageTr31E5EmvMkeyCardPersonalization       KeyUsage = "TR31_E5_EMV_MKEY_CARD_PERSONALIZATION"
	KeyUsageTr31E6EmvMkeyOther                     KeyUsage = "TR31_E6_EMV_MKEY_OTHER"
	KeyUsageTr31K0KeyEncryptionKey                 KeyUsage = "TR31_K0_KEY_ENCRYPTION_KEY"
	KeyUsageTr31K1KeyBlockProtectionKey            KeyUsage = "TR31_K1_KEY_BLOCK_PROTECTION_KEY"
	KeyUsageTr31K3AsymmetricKeyForKeyAgreement     KeyUsage = "TR31_K3_ASYMMETRIC_KEY_FOR_KEY_AGREEMENT"
	KeyUsageTr31M3Iso97973MacKey                   KeyUsage = "TR31_M3_ISO_9797_3_MAC_KEY"
	KeyUsageTr31M1Iso97971MacKey                   KeyUsage = "TR31_M1_ISO_9797_1_MAC_KEY"
	KeyUsageTr31M6Iso97975CmacKey                  KeyUsage = "TR31_M6_ISO_9797_5_CMAC_KEY"
	KeyUsageTr31M7HmacKey                          KeyUsage = "TR31_M7_HMAC_KEY"
	KeyUsageTr31P0PinEncryptionKey                 KeyUsage = "TR31_P0_PIN_ENCRYPTION_KEY"
	KeyUsageTr31P1PinGenerationKey                 KeyUsage = "TR31_P1_PIN_GENERATION_KEY"
	KeyUsageTr31S0AsymmetricKeyForDigitalSignature KeyUsage = "TR31_S0_ASYMMETRIC_KEY_FOR_DIGITAL_SIGNATURE"
	KeyUsageTr31V1Ibm3624PinVerificationKey        KeyUsage = "TR31_V1_IBM3624_PIN_VERIFICATION_KEY"
	KeyUsageTr31V2VisaPinVerificationKey           KeyUsage = "TR31_V2_VISA_PIN_VERIFICATION_KEY"
	KeyUsageTr31K2Tr34AsymmetricKey                KeyUsage = "TR31_K2_TR34_ASYMMETRIC_KEY"
)

// Values returns all known values for KeyUsage. Note that this can be expanded in
// the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (KeyUsage) Values() []KeyUsage {
	return []KeyUsage{
		"TR31_B0_BASE_DERIVATION_KEY",
		"TR31_C0_CARD_VERIFICATION_KEY",
		"TR31_D0_SYMMETRIC_DATA_ENCRYPTION_KEY",
		"TR31_D1_ASYMMETRIC_KEY_FOR_DATA_ENCRYPTION",
		"TR31_E0_EMV_MKEY_APP_CRYPTOGRAMS",
		"TR31_E1_EMV_MKEY_CONFIDENTIALITY",
		"TR31_E2_EMV_MKEY_INTEGRITY",
		"TR31_E4_EMV_MKEY_DYNAMIC_NUMBERS",
		"TR31_E5_EMV_MKEY_CARD_PERSONALIZATION",
		"TR31_E6_EMV_MKEY_OTHER",
		"TR31_K0_KEY_ENCRYPTION_KEY",
		"TR31_K1_KEY_BLOCK_PROTECTION_KEY",
		"TR31_K3_ASYMMETRIC_KEY_FOR_KEY_AGREEMENT",
		"TR31_M3_ISO_9797_3_MAC_KEY",
		"TR31_M1_ISO_9797_1_MAC_KEY",
		"TR31_M6_ISO_9797_5_CMAC_KEY",
		"TR31_M7_HMAC_KEY",
		"TR31_P0_PIN_ENCRYPTION_KEY",
		"TR31_P1_PIN_GENERATION_KEY",
		"TR31_S0_ASYMMETRIC_KEY_FOR_DIGITAL_SIGNATURE",
		"TR31_V1_IBM3624_PIN_VERIFICATION_KEY",
		"TR31_V2_VISA_PIN_VERIFICATION_KEY",
		"TR31_K2_TR34_ASYMMETRIC_KEY",
	}
}

type Tr34KeyBlockFormat string

// Enum values for Tr34KeyBlockFormat
const (
	Tr34KeyBlockFormatX9Tr342012 Tr34KeyBlockFormat = "X9_TR34_2012"
)

// Values returns all known values for Tr34KeyBlockFormat. Note that this can be
// expanded in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (Tr34KeyBlockFormat) Values() []Tr34KeyBlockFormat {
	return []Tr34KeyBlockFormat{
		"X9_TR34_2012",
	}
}

type WrappedKeyMaterialFormat string

// Enum values for WrappedKeyMaterialFormat
const (
	WrappedKeyMaterialFormatKeyCryptogram WrappedKeyMaterialFormat = "KEY_CRYPTOGRAM"
	WrappedKeyMaterialFormatTr31KeyBlock  WrappedKeyMaterialFormat = "TR31_KEY_BLOCK"
	WrappedKeyMaterialFormatTr34KeyBlock  WrappedKeyMaterialFormat = "TR34_KEY_BLOCK"
)

// Values returns all known values for WrappedKeyMaterialFormat. Note that this
// can be expanded in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (WrappedKeyMaterialFormat) Values() []WrappedKeyMaterialFormat {
	return []WrappedKeyMaterialFormat{
		"KEY_CRYPTOGRAM",
		"TR31_KEY_BLOCK",
		"TR34_KEY_BLOCK",
	}
}

type WrappingKeySpec string

// Enum values for WrappingKeySpec
const (
	WrappingKeySpecRsaOaepSha256 WrappingKeySpec = "RSA_OAEP_SHA_256"
	WrappingKeySpecRsaOaepSha512 WrappingKeySpec = "RSA_OAEP_SHA_512"
)

// Values returns all known values for WrappingKeySpec. Note that this can be
// expanded in the future, and so it is only as up to date as the client.
//
// The ordering of this slice is not guaranteed to be stable across updates.
func (WrappingKeySpec) Values() []WrappingKeySpec {
	return []WrappingKeySpec{
		"RSA_OAEP_SHA_256",
		"RSA_OAEP_SHA_512",
	}
}
