// Code generated by smithy-go-codegen DO NOT EDIT.

// Package rekognition provides the API client, operations, and parameter types
// for Amazon Rekognition.
//
// This is the API Reference for [Amazon Rekognition Image], [Amazon Rekognition Custom Labels], [Amazon Rekognition Stored Video], [Amazon Rekognition Streaming Video]. It provides descriptions of actions, data
// types, common parameters, and common errors.
//
// # Amazon Rekognition Image
//
// [AssociateFaces]
//
// [CompareFaces]
//
// [CreateCollection]
//
// [CreateUser]
//
// [DeleteCollection]
//
// [DeleteFaces]
//
// [DeleteUser]
//
// [DescribeCollection]
//
// [DetectFaces]
//
// [DetectLabels]
//
// [DetectModerationLabels]
//
// [DetectProtectiveEquipment]
//
// [DetectText]
//
// [DisassociateFaces]
//
// [GetCelebrityInfo]
//
// [GetMediaAnalysisJob]
//
// [IndexFaces]
//
// [ListCollections]
//
// [ListMediaAnalysisJob]
//
// [ListFaces]
//
// [ListUsers]
//
// [RecognizeCelebrities]
//
// [SearchFaces]
//
// [SearchFacesByImage]
//
// [SearchUsers]
//
// [SearchUsersByImage]
//
// [StartMediaAnalysisJob]
//
// # Amazon Rekognition Custom Labels
//
// [CopyProjectVersion]
//
// [CreateDataset]
//
// [CreateProject]
//
// [CreateProjectVersion]
//
// [DeleteDataset]
//
// [DeleteProject]
//
// [DeleteProjectPolicy]
//
// [DeleteProjectVersion]
//
// [DescribeDataset]
//
// [DescribeProjects]
//
// [DescribeProjectVersions]
//
// [DetectCustomLabels]
//
// [DistributeDatasetEntries]
//
// [ListDatasetEntries]
//
// [ListDatasetLabels]
//
// [ListProjectPolicies]
//
// [PutProjectPolicy]
//
// [StartProjectVersion]
//
// [StopProjectVersion]
//
// [UpdateDatasetEntries]
//
// # Amazon Rekognition Video Stored Video
//
// [GetCelebrityRecognition]
//
// [GetContentModeration]
//
// [GetFaceDetection]
//
// [GetFaceSearch]
//
// [GetLabelDetection]
//
// [GetPersonTracking]
//
// [GetSegmentDetection]
//
// [GetTextDetection]
//
// [StartCelebrityRecognition]
//
// [StartContentModeration]
//
// [StartFaceDetection]
//
// [StartFaceSearch]
//
// [StartLabelDetection]
//
// [StartPersonTracking]
//
// [StartSegmentDetection]
//
// [StartTextDetection]
//
// # Amazon Rekognition Video Streaming Video
//
// [CreateStreamProcessor]
//
// [DeleteStreamProcessor]
//
// [DescribeStreamProcessor]
//
// [ListStreamProcessors]
//
// [StartStreamProcessor]
//
// [StopStreamProcessor]
//
// [UpdateStreamProcessor]
//
// [Amazon Rekognition Custom Labels]: https://docs.aws.amazon.com/rekognition/latest/customlabels-dg/what-is.html
// [DescribeCollection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DescribeCollection.html
// [ListUsers]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListFaces.html
// [DeleteFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteFaces.html
// [ListFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListFaces.html
// [DistributeDatasetEntries]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DistributeDatasetEntries.html
// [DetectProtectiveEquipment]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DetectProtectiveEquipment.html
// [DescribeProjectVersions]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DescribeProjectVersions.html
// [GetMediaAnalysisJob]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetMediaAnalysisJob.html
// [StartTextDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartTextDetection.html
// [SearchFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_SearchFaces.html
// [CreateCollection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CreateCollection.html
// [GetContentModeration]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetContentModeration.html
// [CopyProjectVersion]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CopyProjectVersion.html
// [StartFaceSearch]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartFaceSearch.html
// [SearchUsers]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_SearchUsers.html
// [DeleteCollection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteCollection.html
// [DescribeDataset]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DescribeDataset.html
// [StartCelebrityRecognition]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartCelebrityRecognition.html
// [StartFaceDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartFaceDetection.html
// [UpdateDatasetEntries]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_UpdateDatasetEntries.html
// [DetectFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DetectFaces.html
// [ListCollections]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListCollections.html
// [GetTextDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetTextDetection.html
// [SearchUsersByImage]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_SearchUsersByImage.html
// [DetectModerationLabels]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DetectModerationLabels.html
// [CreateDataset]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CreateDataset.html
// [StartStreamProcessor]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartStreamProcessor.html
// [ListMediaAnalysisJob]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListMediaAnalysisJob.html
// [DescribeStreamProcessor]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DescribeStreamProcessor.html
// [DeleteProject]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteProject.html
// [SearchFacesByImage]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_SearchFacesByImage.html
// [DeleteStreamProcessor]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteStreamProcessor.html
// [RecognizeCelebrities]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_RecognizeCelebrities.html
// [StartMediaAnalysisJob]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartMediaAnalysisJob.html
// [StartSegmentDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartSegmentDetection.html
// [GetPersonTracking]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetPersonTracking.html
// [DetectCustomLabels]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DetectCustomLabels.html
// [StopProjectVersion]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StopProjectVersion.html
// [DeleteUser]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteUser.html
// [DetectText]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DetectText.html
// [PutProjectPolicy]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_PutProjectPolicy.html
// [CreateProject]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CreateProject.html
// [StartPersonTracking]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartPersonTracking.html
// [GetSegmentDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetSegmentDetection.html
// [GetCelebrityRecognition]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetCelebrityRecognition.html
// [ListDatasetEntries]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListDatasetEntries.html
// [IndexFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_IndexFaces.html
// [ListStreamProcessors]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListStreamProcessors.html
// [DeleteProjectVersion]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteProjectVersion.html
// [Amazon Rekognition Streaming Video]: https://docs.aws.amazon.com/rekognition/latest/dg/streaming-video.html
// [DeleteDataset]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteDataset.html
// [StartContentModeration]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartContentModeration.html
// [GetFaceSearch]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetFaceSearch.html
// [Amazon Rekognition Image]: https://docs.aws.amazon.com/rekognition/latest/dg/images.html
// [GetLabelDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetLabelDetection.html
// [GetCelebrityInfo]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetCelebrityInfo.html
// [CompareFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CompareFaces.html
// [Amazon Rekognition Stored Video]: https://docs.aws.amazon.com/rekognition/latest/dg/video.html
// [UpdateStreamProcessor]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_UpdateStreamProcessor.html
// [CreateUser]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CreateUser.html
// [DetectLabels]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DetectLabels.html
// [DeleteProjectPolicy]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DeleteProjectPolicy.html
// [CreateProjectVersion]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CreateProjectVersion.html
// [StopStreamProcessor]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StopStreamProcessor.html
// [DescribeProjects]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DescribeProjects.html
// [StartLabelDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartLabelDetection.html
// [ListProjectPolicies]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListProjectPolicies.html
// [DisassociateFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_DisassociateFaces.html
// [CreateStreamProcessor]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_CreateStreamProcessor.html
// [AssociateFaces]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_AssociateFaces.html
// [ListDatasetLabels]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_ListDatasetLabels.html
// [StartProjectVersion]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_StartProjectVersion.html
// [GetFaceDetection]: https://docs.aws.amazon.com/rekognition/latest/APIReference/API_GetFaceDetection.html
package rekognition
