// Code generated by smithy-go-codegen DO NOT EDIT.

// Package resourceexplorer2 provides the API client, operations, and parameter
// types for AWS Resource Explorer.
//
// Amazon Web Services Resource Explorer is a resource search and discovery
// service. By using Resource Explorer, you can explore your resources using an
// internet search engine-like experience. Examples of resources include Amazon
// Relational Database Service (Amazon RDS) instances, Amazon Simple Storage
// Service (Amazon S3) buckets, or Amazon DynamoDB tables. You can search for your
// resources using resource metadata like names, tags, and IDs. Resource Explorer
// can search across all of the Amazon Web Services Regions in your account in
// which you turn the service on, to simplify your cross-Region workloads.
//
// Resource Explorer scans the resources in each of the Amazon Web Services
// Regions in your Amazon Web Services account in which you turn on Resource
// Explorer. Resource Explorer [creates and maintains an index]in each Region, with the details of that Region's
// resources.
//
// You can [search across all of the indexed Regions in your account] by designating one of your Amazon Web Services Regions to contain the
// aggregator index for the account. When you [promote a local index in a Region to become the aggregator index for the account], Resource Explorer automatically
// replicates the index information from all local indexes in the other Regions to
// the aggregator index. Therefore, the Region with the aggregator index has a copy
// of all resource information for all Regions in the account where you turned on
// Resource Explorer. As a result, views in the aggregator index Region include
// resources from all of the indexed Regions in your account.
//
// For more information about Amazon Web Services Resource Explorer, including how
// to enable and configure the service, see the [Amazon Web Services Resource Explorer User Guide].
//
// [creates and maintains an index]: https://docs.aws.amazon.com/resource-explorer/latest/userguide/getting-started-terms-and-concepts.html#term-index
// [Amazon Web Services Resource Explorer User Guide]: https://docs.aws.amazon.com/resource-explorer/latest/userguide/
// [promote a local index in a Region to become the aggregator index for the account]: https://docs.aws.amazon.com/resource-explorer/latest/userguide/manage-aggregator-region-turn-on.html
// [search across all of the indexed Regions in your account]: https://docs.aws.amazon.com/resource-explorer/latest/userguide/manage-aggregator-region.html
package resourceexplorer2
