// Code generated by smithy-go-codegen DO NOT EDIT.

// Package signer provides the API client, operations, and parameter types for AWS
// Signer.
//
// AWS Signer is a fully managed code-signing service to help you ensure the trust
// and integrity of your code.
//
// Signer supports the following applications:
//
// With code signing for AWS Lambda, you can sign [AWS Lambda] deployment packages. Integrated
// support is provided for [Amazon S3], [Amazon CloudWatch], and [AWS CloudTrail]. In order to sign code, you create a signing
// profile and then use Signer to sign Lambda zip files in S3.
//
// With code signing for IoT, you can sign code for any IoT device that is
// supported by AWS. IoT code signing is available for [Amazon FreeRTOS]and [AWS IoT Device Management], and is integrated
// with [AWS Certificate Manager (ACM)]. In order to sign code, you import a third-party code-signing certificate
// using ACM, and use that to sign updates in Amazon FreeRTOS and AWS IoT Device
// Management.
//
// With Signer and the Notation CLI from the [Notary  Project], you can sign container images
// stored in a container registry such as Amazon Elastic Container Registry (ECR).
// The signatures are stored in the registry alongside the images, where they are
// available for verifying image authenticity and integrity.
//
// For more information about Signer, see the [AWS Signer Developer Guide].
//
// [AWS Lambda]: http://docs.aws.amazon.com/lambda/latest/dg/
// [AWS IoT Device Management]: http://docs.aws.amazon.com/iot/latest/developerguide/
// [AWS Signer Developer Guide]: https://docs.aws.amazon.com/signer/latest/developerguide/Welcome.html
// [Amazon S3]: http://docs.aws.amazon.com/AmazonS3/latest/gsg/
// [AWS CloudTrail]: http://docs.aws.amazon.com/awscloudtrail/latest/userguide/
// [AWS Certificate Manager (ACM)]: http://docs.aws.amazon.com/acm/latest/userguide/
// [Amazon CloudWatch]: http://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/
// [Notary  Project]: https://notaryproject.dev/
// [Amazon FreeRTOS]: http://docs.aws.amazon.com/freertos/latest/userguide/
package signer
