// Code generated by smithy-go-codegen DO NOT EDIT.

package workspaces

import (
	"context"
	"fmt"
	awsmiddleware "github.com/aws/aws-sdk-go-v2/aws/middleware"
	"github.com/aws/aws-sdk-go-v2/service/workspaces/types"
	"github.com/aws/smithy-go/middleware"
	smithyhttp "github.com/aws/smithy-go/transport/http"
)

// Creates a pool of WorkSpaces.
func (c *Client) CreateWorkspacesPool(ctx context.Context, params *CreateWorkspacesPoolInput, optFns ...func(*Options)) (*CreateWorkspacesPoolOutput, error) {
	if params == nil {
		params = &CreateWorkspacesPoolInput{}
	}

	result, metadata, err := c.invokeOperation(ctx, "CreateWorkspacesPool", params, optFns, c.addOperationCreateWorkspacesPoolMiddlewares)
	if err != nil {
		return nil, err
	}

	out := result.(*CreateWorkspacesPoolOutput)
	out.ResultMetadata = metadata
	return out, nil
}

type CreateWorkspacesPoolInput struct {

	// The identifier of the bundle for the pool.
	//
	// This member is required.
	BundleId *string

	// The user capacity of the pool.
	//
	// This member is required.
	Capacity *types.Capacity

	// The pool description.
	//
	// This member is required.
	Description *string

	// The identifier of the directory for the pool.
	//
	// This member is required.
	DirectoryId *string

	// The name of the pool.
	//
	// This member is required.
	PoolName *string

	// Indicates the application settings of the pool.
	ApplicationSettings *types.ApplicationSettingsRequest

	// The tags for the pool.
	Tags []types.Tag

	// Indicates the timeout settings of the pool.
	TimeoutSettings *types.TimeoutSettings

	noSmithyDocumentSerde
}

type CreateWorkspacesPoolOutput struct {

	// Indicates the pool to create.
	WorkspacesPool *types.WorkspacesPool

	// Metadata pertaining to the operation's result.
	ResultMetadata middleware.Metadata

	noSmithyDocumentSerde
}

func (c *Client) addOperationCreateWorkspacesPoolMiddlewares(stack *middleware.Stack, options Options) (err error) {
	if err := stack.Serialize.Add(&setOperationInputMiddleware{}, middleware.After); err != nil {
		return err
	}
	err = stack.Serialize.Add(&awsAwsjson11_serializeOpCreateWorkspacesPool{}, middleware.After)
	if err != nil {
		return err
	}
	err = stack.Deserialize.Add(&awsAwsjson11_deserializeOpCreateWorkspacesPool{}, middleware.After)
	if err != nil {
		return err
	}
	if err := addProtocolFinalizerMiddlewares(stack, options, "CreateWorkspacesPool"); err != nil {
		return fmt.Errorf("add protocol finalizers: %v", err)
	}

	if err = addlegacyEndpointContextSetter(stack, options); err != nil {
		return err
	}
	if err = addSetLoggerMiddleware(stack, options); err != nil {
		return err
	}
	if err = addClientRequestID(stack); err != nil {
		return err
	}
	if err = addComputeContentLength(stack); err != nil {
		return err
	}
	if err = addResolveEndpointMiddleware(stack, options); err != nil {
		return err
	}
	if err = addComputePayloadSHA256(stack); err != nil {
		return err
	}
	if err = addRetry(stack, options); err != nil {
		return err
	}
	if err = addRawResponseToMetadata(stack); err != nil {
		return err
	}
	if err = addRecordResponseTiming(stack); err != nil {
		return err
	}
	if err = addClientUserAgent(stack, options); err != nil {
		return err
	}
	if err = smithyhttp.AddErrorCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = smithyhttp.AddCloseResponseBodyMiddleware(stack); err != nil {
		return err
	}
	if err = addSetLegacyContextSigningOptionsMiddleware(stack); err != nil {
		return err
	}
	if err = addTimeOffsetBuild(stack, c); err != nil {
		return err
	}
	if err = addUserAgentRetryMode(stack, options); err != nil {
		return err
	}
	if err = addOpCreateWorkspacesPoolValidationMiddleware(stack); err != nil {
		return err
	}
	if err = stack.Initialize.Add(newServiceMetadataMiddleware_opCreateWorkspacesPool(options.Region), middleware.Before); err != nil {
		return err
	}
	if err = addRecursionDetection(stack); err != nil {
		return err
	}
	if err = addRequestIDRetrieverMiddleware(stack); err != nil {
		return err
	}
	if err = addResponseErrorMiddleware(stack); err != nil {
		return err
	}
	if err = addRequestResponseLogging(stack, options); err != nil {
		return err
	}
	if err = addDisableHTTPSMiddleware(stack, options); err != nil {
		return err
	}
	return nil
}

func newServiceMetadataMiddleware_opCreateWorkspacesPool(region string) *awsmiddleware.RegisterServiceMetadata {
	return &awsmiddleware.RegisterServiceMetadata{
		Region:        region,
		ServiceID:     ServiceID,
		OperationName: "CreateWorkspacesPool",
	}
}
